﻿Module Utils

    ' =======================================================================================================
    '  Linear Interpolation (and extrapolation) - The first array must be in increasing order 
    ' =======================================================================================================
    Friend Function Interpolate(ByVal x() As Double, ByVal y() As Double, ByVal xvalue As Double) As Double
        Dim i As Int32
        i = 1
        While x(i) < xvalue
            If i = x.Length - 1 Then Exit While
            i = i + 1
        End While
        Return (y(i - 1) + ((xvalue - x(i - 1)) / (x(i) - x(i - 1))) * (y(i) - y(i - 1)))
    End Function

End Module
